export function runAsBuilder(creep: Creep) {
  const memory = creep.memory as CreepMemory & { building: boolean | undefined };

  if (memory.building && creep.store[RESOURCE_ENERGY] === 0) {
    memory.building = false;
    creep.say('🔄 harvest');
  }

  if (!memory.building && creep.store.getFreeCapacity() === 0) {
    memory.building = true;
    creep.say('🚧 build');
  }

  if (memory.building) {
    const targets = creep.room.find(FIND_CONSTRUCTION_SITES);
    if (targets.length > 0) {
      if (creep.build(targets[0]) == ERR_NOT_IN_RANGE) {
        creep.moveTo(targets[0], { visualizePathStyle: { stroke: '#ffffff' } });
      }
    } else {
      const spawns = creep.room.find(FIND_MY_SPAWNS);
      if (spawns.length > 0) {
        creep.say('to spawn');
        creep.moveTo(spawns[0]);
      }
    }
  } else {
    const sources = creep.room.find(FIND_SOURCES);
    if (creep.harvest(sources[0]) == ERR_NOT_IN_RANGE) {
      creep.moveTo(sources[0], { visualizePathStyle: { stroke: '#ffaa00' } });
    }
  }
}
