export function runAsUpgrader(creep: Creep) {
  const memory = creep.memory as CreepMemory & { upgrading: boolean | undefined };

  if (memory.upgrading && creep.store[RESOURCE_ENERGY] === 0) {
    memory.upgrading = false;
    creep.say('🔄 harvest');
  }

  if (!memory.upgrading && creep.store.getFreeCapacity() === 0) {
    memory.upgrading = true;
    creep.say('⚡ upgrade');
  }

  if (memory.upgrading) {
    if (creep.room.controller && creep.upgradeController(creep.room.controller) == ERR_NOT_IN_RANGE) {
      creep.moveTo(creep.room.controller, { visualizePathStyle: { stroke: '#ffffff' } });
    }
  } else {
    const sources = creep.room.find(FIND_SOURCES);
    if (creep.harvest(sources[0]) == ERR_NOT_IN_RANGE) {
      creep.moveTo(sources[0], { visualizePathStyle: { stroke: '#ffaa00' } });
    }
  }
}
